﻿Imports System.Windows.Media.Imaging
Partial Public Class Page
 Inherits UserControl

 Public Sub New()
  InitializeComponent()
 End Sub
 Private Sub stb_Completed(ByVal sender As Object, ByVal e As EventArgs)
  If rc.Children.Count > 0 Then
   StartElementaryAnimation()
  Else
   Pacman.Opacity = 0
  End If
 End Sub

 Private Sub StartElementaryAnimation()
  Dim li As Line = TryCast(rc.Children(0), Line)
  If li IsNot Nothing Then
   daX.From = li.X1 - Pacman.Width / 2
   daX.To = li.X2 - Pacman.Width / 2
   daY.From = li.Y1 - Pacman.Width / 2
   daY.To = li.Y2 - Pacman.Width / 2
   ' calcul de l'angle
   Dim H As Double = li.Y2 - li.Y1, W As Double = li.X2 - li.X1
   Dim angleRad As Double = Math.Atan(H / W)
   Dim angle As Double = angleRad * 360 / 6.28
   If H < 0 AndAlso W < 0 Then
    angle += 180
   End If
   If W < 0 AndAlso H > 0 Then
    angle += 180
   End If
   If H = 0 AndAlso W < 0 Then
    angle = 180
   End If
   If W = 0 AndAlso H < 0 Then
    angle = -90
   End If
   rotPacman.Angle = angle
   rc.Children.RemoveAt(0)
   Select Case rc.Children.Count Mod 2
    Case 0
     imgPacman.Source = New BitmapImage(New Uri("Pacman2.png", UriKind.Relative))
    Case 1
     imgPacman.Source = New BitmapImage(New Uri("Pacman1.png", UriKind.Relative))
   End Select
   stb.Begin()
  End If
 End Sub

 Private bDrawing As Boolean
 Private xPrevPt, yPrevPt As Double
 Private Sub rc_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseEventArgs)
  rc.Children.Clear()
  bDrawing = True
  xPrevPt = e.GetPosition(rc).X ' retenir position précédente
  yPrevPt = e.GetPosition(rc).Y
 End Sub
 Private Sub rc_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseEventArgs)
  bDrawing = False
  Pacman.Opacity = 1
  StartElementaryAnimation()
 End Sub
 Private Sub rc_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
  If bDrawing Then
   Dim li As New Line()
   Dim xCurPt As Double = e.GetPosition(rc).X
   Dim yCurPt As Double = e.GetPosition(rc).Y
   li.X1 = xPrevPt
   li.Y1 = yPrevPt
   li.X2 = xCurPt
   li.Y2 = yCurPt
   li.Stroke = New SolidColorBrush(Colors.Blue)
   li.StrokeThickness = 2
   rc.Children.Add(li)
   xPrevPt = xCurPt
   yPrevPt = yCurPt
  End If
 End Sub
End Class